/*
 * ===========================
 * VDK Visual Develeopment Kit
 * Version 0.4
 * October 1998
 * ===========================
 *
 * Copyright (C) 1998, Salmaso Raffaele
 * Developed by Salmaso Raffaele <r.salmaso@flashnet.it>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#ifndef TOGGLEBUTTON_H
#define TOGGLEBUTTON_H
#include <vdk/abstract_button.h>
#include <vdk/vdkprops.h>
#include <vdk/tooltips.h>

class VDKForm;

class VDKToggleButton: public VDKAbstractButton {
    VDKTooltip* tooltip;
protected:
    int connectId;
    static void ToggleEvent(GtkWidget *wid, gpointer obj);
public:
    // properties
    VDKReadWriteValueProp<VDKToggleButton,bool> Checked;
    //
    VDKToggleButton(VDKForm* owner, char* tip = 0);
    virtual ~VDKToggleButton() {}
    void Toggle() { Checked = Checked ? false : true; }
    void SetChecked(bool flag)
        { gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(widget),flag);}
    bool GetChecked()
        { return GTK_TOGGLE_BUTTON(widget)->active ? true : false; }

    virtual void SetForeground(VDKRgb color, GtkStateType state) {
        _setForeground_(widget,
                        color.red, color.green, color.blue,
                        state);
    }
#ifdef USE_SIGCPLUSPLUS
 public:
/*!
    Extended LS signal system:
    Received when button is toggled
    \param bool status
  */
    VDKSignal1<void, bool> OnButtonToggled;
#endif /* USE_SIGCPLUSPLUS */
};

#endif
